
#ifndef _AUTH2_
#define _AUTH2_

/* DO NOT EDIT: generated by rp2gen from auth2.rpc2 */
#ifdef __cplusplus
extern "C" {
#endif
#include <rpc2/rpc2.h>
#include <rpc2/se.h>
#include <rpc2/errors.h>
#ifdef __cplusplus
}
#endif

 /* BLURB gpl

                           Coda File System
                              Release 6

          Copyright (c) 1987-2003 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the terms of the GNU General Public Licence Version 2, as shown in the
file  LICENSE.  The  technical and financial  contributors to Coda are
listed in the file CREDITS.

                        Additional copyrights

#*/

#define AUTH_SERVICE	"codaauth2"
#define AUTH_SUBSYSID	1993253
#define AUTH_SUCCESS	0
#define AUTH_FAILED	1
#define AUTH_DENIED	2
#define AUTH_BADKEY	3
#define AUTH_READONLY	4
#define AUTH_METHOD_NULL	0
#define AUTH_METHOD_CODATOKENS	1
#define AUTH_METHOD_CODAUSERNAME	2
#define AUTH_METHOD_KERBEROS4	3
#define AUTH_METHOD_KERBEROS5	4
#define AUTH_METHOD_PK	5
#define AUTH_METHOD_VICEKEY	6
#define AUTH_SETTOKENS	3
#define AUTH_GETTOKENS	9
#define AUTH_DELETETOKENS	8

typedef RPC2_Byte AuthMagic[16];
#define AUTH_MAGICVALUE	"authentication"

typedef struct SecretToken {
    AuthMagic MagicString;
    RPC2_Integer AuthHandle;
    RPC2_Integer Noise1;
    RPC2_Integer ViceId;
    RPC2_Integer BeginTimestamp;
    RPC2_Integer Noise2;
    RPC2_Integer EndTimestamp;
    RPC2_Integer Noise3;
    RPC2_EncryptionKey HandShakeKey;
    RPC2_Integer Noise4;
} SecretToken;

typedef RPC2_Byte EncryptedSecretToken[56];

typedef struct ClearToken {
    RPC2_Integer AuthHandle;
    RPC2_EncryptionKey HandShakeKey;
    RPC2_Integer ViceId;
    RPC2_Integer BeginTimestamp;
    RPC2_Integer EndTimestamp;
} ClearToken;

#define auth2_HEAD_VERSION	1344030171

#ifndef _STUB_PREDEFINED_
#define _STUB_PREDEFINED_

typedef struct CallCountEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
} CallCountEntry;

typedef struct MultiCallEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
    RPC2_Integer counthost;
} MultiCallEntry;

typedef struct MultiStubWork {
    RPC2_Integer opengate;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
} MultiStubWork;
#endif /* _STUB_PREDEFINED_ */

/* Op codes and definitions */

#ifdef __cplusplus
extern "C"{
#endif
long auth2_ExecuteRequest(RPC2_Handle cid, RPC2_PacketBuffer *pb, SE_Descriptor *se);

extern long S_AuthNewConn(RPC2_Handle cid, RPC2_Integer SideEffectType, RPC2_Integer SecurityLevel, RPC2_Integer EncryptionType, RPC2_Integer AuthType, RPC2_CountedBS *ClientIdent);
long AuthChangePasswd(RPC2_Handle cid, RPC2_Integer viceId, RPC2_String newPasswd);
long S_AuthChangePasswd(RPC2_Handle cid, RPC2_Integer viceId, RPC2_String newPasswd);
#define AuthChangePasswd_OP	1
extern ARG AuthChangePasswd_ARGS[];
#define AuthChangePasswd_PTR	AuthChangePasswd_ARGS

long AuthGetTokens(RPC2_Handle cid, EncryptedSecretToken sToken, ClearToken *cToken);
long S_AuthGetTokens(RPC2_Handle cid, EncryptedSecretToken sToken, ClearToken *cToken);
#define AuthGetTokens_OP	2
extern ARG AuthGetTokens_ARGS[];
#define AuthGetTokens_PTR	AuthGetTokens_ARGS

long AuthChangeUser(RPC2_Handle cid, RPC2_Integer viceId, RPC2_EncryptionKey initKey, RPC2_String otherInfo);
long S_AuthChangeUser(RPC2_Handle cid, RPC2_Integer viceId, RPC2_EncryptionKey initKey, RPC2_String otherInfo);
#define AuthChangeUser_OP	3
extern ARG AuthChangeUser_ARGS[];
#define AuthChangeUser_PTR	AuthChangeUser_ARGS

long AuthNewUser(RPC2_Handle cid, RPC2_Integer viceId, RPC2_EncryptionKey initKey, RPC2_String otherInfo);
long S_AuthNewUser(RPC2_Handle cid, RPC2_Integer viceId, RPC2_EncryptionKey initKey, RPC2_String otherInfo);
#define AuthNewUser_OP	4
extern ARG AuthNewUser_ARGS[];
#define AuthNewUser_PTR	AuthNewUser_ARGS

long AuthDeleteUser(RPC2_Handle cid, RPC2_Integer viceId);
long S_AuthDeleteUser(RPC2_Handle cid, RPC2_Integer viceId);
#define AuthDeleteUser_OP	5
extern ARG AuthDeleteUser_ARGS[];
#define AuthDeleteUser_PTR	AuthDeleteUser_ARGS

long AuthNameToId(RPC2_Handle cid, RPC2_String viceName, RPC2_Integer *viceId);
long S_AuthNameToId(RPC2_Handle cid, RPC2_String viceName, RPC2_Integer *viceId);
#define AuthNameToId_OP	6
extern ARG AuthNameToId_ARGS[];
#define AuthNameToId_PTR	AuthNameToId_ARGS

long AuthQuit(RPC2_Handle cid);
long S_AuthQuit(RPC2_Handle cid);
#define AuthQuit_OP	7
extern ARG AuthQuit_ARGS[];
#define AuthQuit_PTR	AuthQuit_ARGS

#ifdef __cplusplus
}
#endif
#define auth2OPARRAYSIZE 8

extern CallCountEntry auth2_CallCount[];

extern MultiCallEntry auth2_MultiCall[];

extern MultiStubWork auth2_MultiStubWork[];

extern long auth2_ElapseSwitch;

extern long auth2_EnqueueRequest;

#endif /* _AUTH2_ */
