
#ifndef _VICE_
#define _VICE_

/* DO NOT EDIT: generated by rp2gen from vice.rpc2 */
#ifdef __cplusplus
extern "C" {
#endif
#include <rpc2/rpc2.h>
#include <rpc2/se.h>
#include <rpc2/errors.h>
#ifdef __cplusplus
}
#endif

 /* BLURB lgpl

                           Coda File System
                              Release 6

          Copyright (c) 1987-2003 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the  terms of the  GNU  Library General Public Licence  Version 2,  as
shown in the file LICENSE. The technical and financial contributors to
Coda are listed in the file CREDITS.

                        Additional copyrights
              Copyright (c) 2002-2003 Intel Corporation
#*/

/*
                         IBM COPYRIGHT NOTICE

                          Copyright (C) 1986
             International Business Machines Corporation
                         All Rights Reserved

This  file  contains  some  code identical to or derived from the 1986
version of the Andrew File System ("AFS"), which is owned by  the  IBM
Corporation.   This  code is provided "AS IS" and IBM does not warrant
that it is free of infringement of  any  intellectual  rights  of  any
third  party.    IBM  disclaims  liability of any kind for any damages
whatsoever resulting directly or indirectly from use of this  software
or  of  any  derivative work.  Carnegie Mellon University has obtained
permission to  modify,  distribute and sublicense this code,  which is
based on Version 2  of  AFS  and  does  not  contain  the features and
enhancements that are part of  Version 3 of  AFS.  Version 3 of AFS is
commercially   available   and  supported  by   Transarc  Corporation,
Pittsburgh, PA.

*/

#define SUBSYS_SRV	1001

extern char *ViceErrorMsg(int errorCode);

#define VICE_VERSION	3
#ifndef _vcrcommon_rpc2_
#define _vcrcommon_rpc2_
#include "vcrcommon.h"
#endif /* _vcrcommon_rpc2_ */
#define SET_TIME	1
#define SET_MODE	2
#define SET_OWNER	4
#define SET_LENGTH	8

typedef enum{ ReadOnly=0, ReadWrite=1, Backup=2, Replicated=3 } ViceVolumeType;

typedef RPC2_Byte DiskName[V_MAXPARTNAMELEN];

typedef struct ViceDisk {
    RPC2_Integer BlocksAvailable;
    RPC2_Integer TotalBlocks;
    DiskName Name;
} ViceDisk;

typedef struct ViceStatistics {
    RPC2_Unsigned Obsolete1;
    RPC2_Unsigned Obsolete2;
    RPC2_Unsigned CurrentTime;
    RPC2_Unsigned BootTime;
    RPC2_Unsigned StartTime;
    RPC2_Unsigned CurrentConnections;
    RPC2_Unsigned TotalViceCalls;
    RPC2_Unsigned TotalFetches;
    RPC2_Unsigned FetchDatas;
    RPC2_Unsigned FetchedBytes;
    RPC2_Unsigned FetchDataRate;
    RPC2_Unsigned TotalStores;
    RPC2_Unsigned StoreDatas;
    RPC2_Unsigned StoredBytes;
    RPC2_Unsigned StoreDataRate;
    RPC2_Unsigned TotalRPCBytesSent;
    RPC2_Unsigned TotalRPCBytesReceived;
    RPC2_Unsigned TotalRPCPacketsSent;
    RPC2_Unsigned TotalRPCPacketsReceived;
    RPC2_Unsigned TotalRPCPacketsLost;
    RPC2_Unsigned TotalRPCBogusPackets;
    RPC2_Unsigned SystemCPU;
    RPC2_Unsigned UserCPU;
    RPC2_Unsigned NiceCPU;
    RPC2_Unsigned IdleCPU;
    RPC2_Unsigned TotalIO;
    RPC2_Unsigned ActiveVM;
    RPC2_Unsigned TotalVM;
    RPC2_Unsigned EtherNetTotalErrors;
    RPC2_Unsigned EtherNetTotalWrites;
    RPC2_Unsigned EtherNetTotalInterupts;
    RPC2_Unsigned EtherNetGoodReads;
    RPC2_Unsigned EtherNetTotalBytesWritten;
    RPC2_Unsigned EtherNetTotalBytesRead;
    RPC2_Unsigned ProcessSize;
    RPC2_Unsigned WorkStations;
    RPC2_Unsigned ActiveWorkStations;
    RPC2_Unsigned MinFlt;
    RPC2_Unsigned MajFlt;
    RPC2_Unsigned NSwaps;
    RPC2_Unsigned Spare4;
    RPC2_Unsigned UsrTime;
    RPC2_Unsigned SysTime;
    RPC2_Unsigned VmRSS;
    RPC2_Unsigned VmData;
    ViceDisk Disk1;
    ViceDisk Disk2;
    ViceDisk Disk3;
    ViceDisk Disk4;
    ViceDisk Disk5;
    ViceDisk Disk6;
    ViceDisk Disk7;
    ViceDisk Disk8;
    ViceDisk Disk9;
    ViceDisk Disk10;
} ViceStatistics;

typedef struct VolumeStatus {
    VolumeId Vid;
    VolumeId ParentId;
    RPC2_Byte Online;
    RPC2_Byte InService;
    RPC2_Byte Blessed;
    RPC2_Byte NeedsSalvage;
    ViceVolumeType Type;
    RPC2_Integer MinQuota;
    RPC2_Integer MaxQuota;
    RPC2_Integer BlocksInUse;
    RPC2_Integer PartBlocksAvail;
    RPC2_Integer PartMaxBlocks;
    RPC2_Integer Unused;
} VolumeStatus;

typedef struct ViceRepVolMap {
    VolumeId Volume0;
    VolumeId Volume1;
    VolumeId Volume2;
    VolumeId Volume3;
    VolumeId Volume4;
    VolumeId Volume5;
    VolumeId Volume6;
    VolumeId Volume7;
} ViceRepVolMap;

typedef struct VolumeInfo {
    VolumeId Vid;
    RPC2_Integer Type;
    VolumeId Type0;
    VolumeId Type1;
    VolumeId Type2;
    VolumeId Type3;
    VolumeId Type4;
    RPC2_Unsigned ServerCount;
    RPC2_Unsigned Server0;
    RPC2_Unsigned Server1;
    RPC2_Unsigned Server2;
    RPC2_Unsigned Server3;
    RPC2_Unsigned Server4;
    RPC2_Unsigned Server5;
    RPC2_Unsigned Server6;
    RPC2_Unsigned Server7;
    RPC2_Unsigned VSGAddr;
    ViceRepVolMap RepVolMap;
} VolumeInfo;

typedef enum{ LockRead=0, LockWrite=1 } ViceLockType;

typedef enum{ NoSalvage=0, Salvage=1 } ViceOfflineType;

typedef struct ViceFidRange {
    VnodeId Vnode;
    Unique_t Unique;
    RPC2_Integer Stride;
    RPC2_Integer Count;
} ViceFidRange;

typedef struct ViceFidAndVV {
    ViceFid Fid;
    ViceVersionVector VV;
} ViceFidAndVV;

typedef RPC2_Byte ViceUUID[16];

typedef struct ViceClient {
    RPC2_String UserName;
    RPC2_String WorkStationName;
    RPC2_String VenusName;
    ViceUUID VenusUUID;
} ViceClient;

typedef struct ViceVolumeIdStruct {
    VolumeId Vid;
} ViceVolumeIdStruct;

typedef struct ViceReintHandle {
    RPC2_Integer BirthTime;
    RPC2_Integer Device;
    RPC2_Integer Inode;
} ViceReintHandle;

#define srv_HEAD_VERSION	1344030163

#ifndef _STUB_PREDEFINED_
#define _STUB_PREDEFINED_

typedef struct CallCountEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
} CallCountEntry;

typedef struct MultiCallEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
    RPC2_Integer counthost;
} MultiCallEntry;

typedef struct MultiStubWork {
    RPC2_Integer opengate;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
} MultiStubWork;
#endif /* _STUB_PREDEFINED_ */

/* Op codes and definitions */

#ifdef __cplusplus
extern "C"{
#endif
long srv_ExecuteRequest(RPC2_Handle cid, RPC2_PacketBuffer *pb, SE_Descriptor *se);

extern long FS_ViceNewConnection(RPC2_Handle cid, RPC2_Integer SideEffectType, RPC2_Integer SecurityLevel, RPC2_Integer EncryptionType, RPC2_Integer AuthType, RPC2_CountedBS *ClientIdent);
long ViceGetAttr(RPC2_Handle cid, ViceFid *Fid, RPC2_Unsigned InconOK, ViceStatus *Status, RPC2_Unsigned PrimaryHost, RPC2_CountedBS *PiggyCOP2);
long FS_ViceGetAttr(RPC2_Handle cid, ViceFid *Fid, RPC2_Unsigned InconOK, ViceStatus *Status, RPC2_Unsigned PrimaryHost, RPC2_CountedBS *PiggyCOP2);
#define ViceGetAttr_OP	1
extern ARG ViceGetAttr_ARGS[];
#define ViceGetAttr_PTR	ViceGetAttr_ARGS

long ViceGetACL(RPC2_Handle cid, ViceFid *Fid, RPC2_Unsigned InconOK, RPC2_BoundedBS *AccessList, ViceStatus *Status, RPC2_Unsigned PrimaryHost, RPC2_CountedBS *PiggyCOP2);
long FS_ViceGetACL(RPC2_Handle cid, ViceFid *Fid, RPC2_Unsigned InconOK, RPC2_BoundedBS *AccessList, ViceStatus *Status, RPC2_Unsigned PrimaryHost, RPC2_CountedBS *PiggyCOP2);
#define ViceGetACL_OP	2
extern ARG ViceGetACL_ARGS[];
#define ViceGetACL_PTR	ViceGetACL_ARGS

long ViceFetch(RPC2_Handle cid, ViceFid *Fid, ViceVersionVector *VV, RPC2_Unsigned InconOK, ViceStatus *Status, RPC2_Unsigned PrimaryHost, RPC2_Unsigned Offset, RPC2_CountedBS *PiggyCOP2, SE_Descriptor *BD);
long FS_ViceFetch(RPC2_Handle cid, ViceFid *Fid, ViceVersionVector *VV, RPC2_Unsigned InconOK, ViceStatus *Status, RPC2_Unsigned PrimaryHost, RPC2_Unsigned Offset, RPC2_CountedBS *PiggyCOP2, SE_Descriptor *BD);
#define ViceFetch_OP	3
extern ARG ViceFetch_ARGS[];
#define ViceFetch_PTR	ViceFetch_ARGS

long ViceSetAttr(RPC2_Handle cid, ViceFid *Fid, ViceStatus *Status, RPC2_Integer Mask, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
long FS_ViceSetAttr(RPC2_Handle cid, ViceFid *Fid, ViceStatus *Status, RPC2_Integer Mask, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
#define ViceSetAttr_OP	4
extern ARG ViceSetAttr_ARGS[];
#define ViceSetAttr_PTR	ViceSetAttr_ARGS

long ViceSetACL(RPC2_Handle cid, ViceFid *Fid, RPC2_CountedBS *AccessList, ViceStatus *Status, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
long FS_ViceSetACL(RPC2_Handle cid, ViceFid *Fid, RPC2_CountedBS *AccessList, ViceStatus *Status, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
#define ViceSetACL_OP	5
extern ARG ViceSetACL_ARGS[];
#define ViceSetACL_PTR	ViceSetACL_ARGS

long ViceStore(RPC2_Handle cid, ViceFid *Fid, ViceStatus *Status, RPC2_Integer Length, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2, SE_Descriptor *BD);
long FS_ViceStore(RPC2_Handle cid, ViceFid *Fid, ViceStatus *Status, RPC2_Integer Length, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2, SE_Descriptor *BD);
#define ViceStore_OP	6
extern ARG ViceStore_ARGS[];
#define ViceStore_PTR	ViceStore_ARGS

long ViceGetRootVolume(RPC2_Handle cid, RPC2_BoundedBS *Volume);
long FS_ViceGetRootVolume(RPC2_Handle cid, RPC2_BoundedBS *Volume);
#define ViceGetRootVolume_OP	15
extern ARG ViceGetRootVolume_ARGS[];
#define ViceGetRootVolume_PTR	ViceGetRootVolume_ARGS

long ViceSetRootVolume(RPC2_Handle cid, RPC2_String Volume);
long FS_ViceSetRootVolume(RPC2_Handle cid, RPC2_String Volume);
#define ViceSetRootVolume_OP	16
extern ARG ViceSetRootVolume_ARGS[];
#define ViceSetRootVolume_PTR	ViceSetRootVolume_ARGS

long ViceGetVolumeStatus(RPC2_Handle cid, VolumeId Vid, VolumeStatus *Status, RPC2_BoundedBS *Name, RPC2_BoundedBS *OfflineMsg, RPC2_BoundedBS *MOTD, RPC2_Unsigned PrimaryHost);
long FS_ViceGetVolumeStatus(RPC2_Handle cid, VolumeId Vid, VolumeStatus *Status, RPC2_BoundedBS *Name, RPC2_BoundedBS *OfflineMsg, RPC2_BoundedBS *MOTD, RPC2_Unsigned PrimaryHost);
#define ViceGetVolumeStatus_OP	17
extern ARG ViceGetVolumeStatus_ARGS[];
#define ViceGetVolumeStatus_PTR	ViceGetVolumeStatus_ARGS

long ViceSetVolumeStatus(RPC2_Handle cid, VolumeId Vid, VolumeStatus *Status, RPC2_BoundedBS *Name, RPC2_BoundedBS *OfflineMsg, RPC2_BoundedBS *MOTD, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *PiggyCOP2);
long FS_ViceSetVolumeStatus(RPC2_Handle cid, VolumeId Vid, VolumeStatus *Status, RPC2_BoundedBS *Name, RPC2_BoundedBS *OfflineMsg, RPC2_BoundedBS *MOTD, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *PiggyCOP2);
#define ViceSetVolumeStatus_OP	18
extern ARG ViceSetVolumeStatus_ARGS[];
#define ViceSetVolumeStatus_PTR	ViceSetVolumeStatus_ARGS

long ViceDisconnectFS(RPC2_Handle cid);
long FS_ViceDisconnectFS(RPC2_Handle cid);
#define ViceDisconnectFS_OP	19
extern ARG ViceDisconnectFS_ARGS[];
#define ViceDisconnectFS_PTR	ViceDisconnectFS_ARGS

long ViceGetTime(RPC2_Handle cid, RPC2_Unsigned *Seconds, RPC2_Integer *USeconds);
long FS_ViceGetTime(RPC2_Handle cid, RPC2_Unsigned *Seconds, RPC2_Integer *USeconds);
#define ViceGetTime_OP	20
extern ARG ViceGetTime_ARGS[];
#define ViceGetTime_PTR	ViceGetTime_ARGS

long TokenExpired(RPC2_Handle cid);
long FS_TokenExpired(RPC2_Handle cid);
#define TokenExpired_OP	21
extern ARG TokenExpired_ARGS[];
#define TokenExpired_PTR	TokenExpired_ARGS

long ViceGetOldStatistics(RPC2_Handle cid, ViceStatistics *Statistics);
long FS_ViceGetOldStatistics(RPC2_Handle cid, ViceStatistics *Statistics);
#define ViceGetOldStatistics_OP	22
extern ARG ViceGetOldStatistics_ARGS[];
#define ViceGetOldStatistics_PTR	ViceGetOldStatistics_ARGS

long ViceGetStatistics(RPC2_Handle cid, ViceStatistics *Statistics);
long FS_ViceGetStatistics(RPC2_Handle cid, ViceStatistics *Statistics);
#define ViceGetStatistics_OP	23
extern ARG ViceGetStatistics_ARGS[];
#define ViceGetStatistics_PTR	ViceGetStatistics_ARGS

long ViceGetVolumeInfo(RPC2_Handle cid, RPC2_String Vid, VolumeInfo *Info);
long FS_ViceGetVolumeInfo(RPC2_Handle cid, RPC2_String Vid, VolumeInfo *Info);
#define ViceGetVolumeInfo_OP	24
extern ARG ViceGetVolumeInfo_ARGS[];
#define ViceGetVolumeInfo_PTR	ViceGetVolumeInfo_ARGS

long ViceGetVolumeLocation(RPC2_Handle cid, VolumeId Vid, RPC2_BoundedBS *HostPort);
long FS_ViceGetVolumeLocation(RPC2_Handle cid, VolumeId Vid, RPC2_BoundedBS *HostPort);
#define ViceGetVolumeLocation_OP	26
extern ARG ViceGetVolumeLocation_ARGS[];
#define ViceGetVolumeLocation_PTR	ViceGetVolumeLocation_ARGS

long ViceCOP2(RPC2_Handle cid, RPC2_CountedBS *COP2BS);
long FS_ViceCOP2(RPC2_Handle cid, RPC2_CountedBS *COP2BS);
#define ViceCOP2_OP	29
extern ARG ViceCOP2_ARGS[];
#define ViceCOP2_PTR	ViceCOP2_ARGS

long ViceResolve(RPC2_Handle cid, ViceFid *Fid);
long FS_ViceResolve(RPC2_Handle cid, ViceFid *Fid);
#define ViceResolve_OP	30
extern ARG ViceResolve_ARGS[];
#define ViceResolve_PTR	ViceResolve_ARGS

long ViceRepair(RPC2_Handle cid, ViceFid *Fid, ViceStatus *status, ViceStoreId *StoreId, SE_Descriptor *BD);
long FS_ViceRepair(RPC2_Handle cid, ViceFid *Fid, ViceStatus *status, ViceStoreId *StoreId, SE_Descriptor *BD);
#define ViceRepair_OP	33
extern ARG ViceRepair_ARGS[];
#define ViceRepair_PTR	ViceRepair_ARGS

long ViceSetVV(RPC2_Handle cid, ViceFid *Fid, ViceVersionVector *VV, RPC2_CountedBS *PiggyCOP2);
long FS_ViceSetVV(RPC2_Handle cid, ViceFid *Fid, ViceVersionVector *VV, RPC2_CountedBS *PiggyCOP2);
#define ViceSetVV_OP	34
extern ARG ViceSetVV_ARGS[];
#define ViceSetVV_PTR	ViceSetVV_ARGS

long ViceAllocFids(RPC2_Handle cid, VolumeId Vid, ViceDataType Type, ViceFidRange *Range, RPC2_Unsigned AllocHost, RPC2_CountedBS *PiggyCOP2);
long FS_ViceAllocFids(RPC2_Handle cid, VolumeId Vid, ViceDataType Type, ViceFidRange *Range, RPC2_Unsigned AllocHost, RPC2_CountedBS *PiggyCOP2);
#define ViceAllocFids_OP	37
extern ARG ViceAllocFids_ARGS[];
#define ViceAllocFids_PTR	ViceAllocFids_ARGS

long ViceValidateAttrs(RPC2_Handle cid, RPC2_Unsigned PrimaryHost, ViceFid *PrimaryFid, ViceStatus *PrimaryStatus, RPC2_Integer Piggies_size_, ViceFidAndVV Piggies[], RPC2_BoundedBS *VFlagBS, RPC2_CountedBS *PiggyCOP2);
long FS_ViceValidateAttrs(RPC2_Handle cid, RPC2_Unsigned PrimaryHost, ViceFid *PrimaryFid, ViceStatus *PrimaryStatus, RPC2_Integer Piggies_size_, ViceFidAndVV Piggies[], RPC2_BoundedBS *VFlagBS, RPC2_CountedBS *PiggyCOP2);
#define ViceValidateAttrs_OP	38
extern ARG ViceValidateAttrs_ARGS[];
#define ViceValidateAttrs_PTR	ViceValidateAttrs_ARGS

long ViceNewConnectFS(RPC2_Handle cid, RPC2_Unsigned ViceVersion, ViceClient *ClientId);
long FS_ViceNewConnectFS(RPC2_Handle cid, RPC2_Unsigned ViceVersion, ViceClient *ClientId);
#define ViceNewConnectFS_OP	40
extern ARG ViceNewConnectFS_ARGS[];
#define ViceNewConnectFS_PTR	ViceNewConnectFS_ARGS

long ViceGetVolVS(RPC2_Handle cid, VolumeId Vid, RPC2_Integer *VS, CallBackStatus *CBStatus);
long FS_ViceGetVolVS(RPC2_Handle cid, VolumeId Vid, RPC2_Integer *VS, CallBackStatus *CBStatus);
#define ViceGetVolVS_OP	41
extern ARG ViceGetVolVS_ARGS[];
#define ViceGetVolVS_PTR	ViceGetVolVS_ARGS

long ViceValidateVols(RPC2_Handle cid, RPC2_Integer Vids_size_, ViceVolumeIdStruct Vids[], RPC2_CountedBS *VS, RPC2_BoundedBS *VFlagBS);
long FS_ViceValidateVols(RPC2_Handle cid, RPC2_Integer Vids_size_, ViceVolumeIdStruct Vids[], RPC2_CountedBS *VS, RPC2_BoundedBS *VFlagBS);
#define ViceValidateVols_OP	42
extern ARG ViceValidateVols_ARGS[];
#define ViceValidateVols_PTR	ViceValidateVols_ARGS

long ViceVRemove(RPC2_Handle cid, ViceFid *Did, RPC2_String Name, ViceStatus *DirStatus, ViceStatus *Status, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
long FS_ViceVRemove(RPC2_Handle cid, ViceFid *Did, RPC2_String Name, ViceStatus *DirStatus, ViceStatus *Status, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
#define ViceVRemove_OP	45
extern ARG ViceVRemove_ARGS[];
#define ViceVRemove_PTR	ViceVRemove_ARGS

long ViceVCreate(RPC2_Handle cid, ViceFid *Did, ViceFid *BidFid, RPC2_String Name, ViceStatus *Status, ViceFid *Fid, ViceStatus *DirStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
long FS_ViceVCreate(RPC2_Handle cid, ViceFid *Did, ViceFid *BidFid, RPC2_String Name, ViceStatus *Status, ViceFid *Fid, ViceStatus *DirStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
#define ViceVCreate_OP	46
extern ARG ViceVCreate_ARGS[];
#define ViceVCreate_PTR	ViceVCreate_ARGS

long ViceVRename(RPC2_Handle cid, ViceFid *OldDid, RPC2_String OldName, ViceFid *NewDid, RPC2_String NewName, ViceStatus *OldDirStatus, ViceStatus *NewDirStatus, ViceStatus *SrcStatus, ViceStatus *TgtStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
long FS_ViceVRename(RPC2_Handle cid, ViceFid *OldDid, RPC2_String OldName, ViceFid *NewDid, RPC2_String NewName, ViceStatus *OldDirStatus, ViceStatus *NewDirStatus, ViceStatus *SrcStatus, ViceStatus *TgtStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
#define ViceVRename_OP	47
extern ARG ViceVRename_ARGS[];
#define ViceVRename_PTR	ViceVRename_ARGS

long ViceVSymLink(RPC2_Handle cid, ViceFid *Did, RPC2_String OldName, RPC2_String NewName, ViceFid *Fid, ViceStatus *Status, ViceStatus *DirStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
long FS_ViceVSymLink(RPC2_Handle cid, ViceFid *Did, RPC2_String OldName, RPC2_String NewName, ViceFid *Fid, ViceStatus *Status, ViceStatus *DirStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
#define ViceVSymLink_OP	48
extern ARG ViceVSymLink_ARGS[];
#define ViceVSymLink_PTR	ViceVSymLink_ARGS

long ViceVLink(RPC2_Handle cid, ViceFid *Did, RPC2_String Name, ViceFid *Fid, ViceStatus *Status, ViceStatus *DirStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
long FS_ViceVLink(RPC2_Handle cid, ViceFid *Did, RPC2_String Name, ViceFid *Fid, ViceStatus *Status, ViceStatus *DirStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
#define ViceVLink_OP	49
extern ARG ViceVLink_ARGS[];
#define ViceVLink_PTR	ViceVLink_ARGS

long ViceVMakeDir(RPC2_Handle cid, ViceFid *Did, RPC2_String Name, ViceStatus *Status, ViceFid *NewDid, ViceStatus *DirStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
long FS_ViceVMakeDir(RPC2_Handle cid, ViceFid *Did, RPC2_String Name, ViceStatus *Status, ViceFid *NewDid, ViceStatus *DirStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
#define ViceVMakeDir_OP	50
extern ARG ViceVMakeDir_ARGS[];
#define ViceVMakeDir_PTR	ViceVMakeDir_ARGS

long ViceVRemoveDir(RPC2_Handle cid, ViceFid *Did, RPC2_String Name, ViceStatus *Status, ViceStatus *TgtStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
long FS_ViceVRemoveDir(RPC2_Handle cid, ViceFid *Did, RPC2_String Name, ViceStatus *Status, ViceStatus *TgtStatus, RPC2_Unsigned PrimaryHost, ViceStoreId *StoreId, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2);
#define ViceVRemoveDir_OP	51
extern ARG ViceVRemoveDir_ARGS[];
#define ViceVRemoveDir_PTR	ViceVRemoveDir_ARGS

long ViceOpenReintHandle(RPC2_Handle cid, ViceFid *Fid, ViceReintHandle *RHandle);
long FS_ViceOpenReintHandle(RPC2_Handle cid, ViceFid *Fid, ViceReintHandle *RHandle);
#define ViceOpenReintHandle_OP	55
extern ARG ViceOpenReintHandle_ARGS[];
#define ViceOpenReintHandle_PTR	ViceOpenReintHandle_ARGS

long ViceQueryReintHandle(RPC2_Handle cid, VolumeId Vid, ViceReintHandle *RHandle, RPC2_Unsigned *Length);
long FS_ViceQueryReintHandle(RPC2_Handle cid, VolumeId Vid, ViceReintHandle *RHandle, RPC2_Unsigned *Length);
#define ViceQueryReintHandle_OP	56
extern ARG ViceQueryReintHandle_ARGS[];
#define ViceQueryReintHandle_PTR	ViceQueryReintHandle_ARGS

long ViceSendReintFragment(RPC2_Handle cid, VolumeId Vid, ViceReintHandle *RHandle, RPC2_Unsigned Length, SE_Descriptor *BD);
long FS_ViceSendReintFragment(RPC2_Handle cid, VolumeId Vid, ViceReintHandle *RHandle, RPC2_Unsigned Length, SE_Descriptor *BD);
#define ViceSendReintFragment_OP	57
extern ARG ViceSendReintFragment_ARGS[];
#define ViceSendReintFragment_PTR	ViceSendReintFragment_ARGS

long ViceCloseReintHandle(RPC2_Handle cid, VolumeId Vid, RPC2_Integer LogSize, ViceReintHandle *RHandle, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2, SE_Descriptor *BD);
long FS_ViceCloseReintHandle(RPC2_Handle cid, VolumeId Vid, RPC2_Integer LogSize, ViceReintHandle *RHandle, RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2, SE_Descriptor *BD);
#define ViceCloseReintHandle_OP	58
extern ARG ViceCloseReintHandle_ARGS[];
#define ViceCloseReintHandle_PTR	ViceCloseReintHandle_ARGS

long ViceReintegrate(RPC2_Handle cid, VolumeId Vid, RPC2_Integer LogSize, RPC2_Integer *Index, RPC2_Integer OutOfOrder, RPC2_Integer StaleDirs_size_max_, RPC2_Integer *StaleDirs_size_, ViceFid StaleDirs[], RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2, SE_Descriptor *BD);
long FS_ViceReintegrate(RPC2_Handle cid, VolumeId Vid, RPC2_Integer LogSize, RPC2_Integer *Index, RPC2_Integer OutOfOrder, RPC2_Integer StaleDirs_size_max_, RPC2_Integer *StaleDirs_size_, ViceFid StaleDirs[], RPC2_CountedBS *OldVS, RPC2_Integer *NewVS, CallBackStatus *VCBStatus, RPC2_CountedBS *PiggyCOP2, SE_Descriptor *BD);
#define ViceReintegrate_OP	59
extern ARG ViceReintegrate_ARGS[];
#define ViceReintegrate_PTR	ViceReintegrate_ARGS

long ViceGetAttrPlusSHA(RPC2_Handle cid, ViceFid *Fid, RPC2_Unsigned InconOK, ViceStatus *Status, RPC2_BoundedBS *SHAval, RPC2_Unsigned PrimaryHost, RPC2_CountedBS *PiggyCOP2);
long FS_ViceGetAttrPlusSHA(RPC2_Handle cid, ViceFid *Fid, RPC2_Unsigned InconOK, ViceStatus *Status, RPC2_BoundedBS *SHAval, RPC2_Unsigned PrimaryHost, RPC2_CountedBS *PiggyCOP2);
#define ViceGetAttrPlusSHA_OP	63
extern ARG ViceGetAttrPlusSHA_ARGS[];
#define ViceGetAttrPlusSHA_PTR	ViceGetAttrPlusSHA_ARGS

long ViceValidateAttrsPlusSHA(RPC2_Handle cid, RPC2_Unsigned PrimaryHost, ViceFid *PrimaryFid, ViceStatus *PrimaryStatus, RPC2_BoundedBS *SHAval, RPC2_Integer Piggies_size_, ViceFidAndVV Piggies[], RPC2_BoundedBS *VFlagBS, RPC2_CountedBS *PiggyCOP2);
long FS_ViceValidateAttrsPlusSHA(RPC2_Handle cid, RPC2_Unsigned PrimaryHost, ViceFid *PrimaryFid, ViceStatus *PrimaryStatus, RPC2_BoundedBS *SHAval, RPC2_Integer Piggies_size_, ViceFidAndVV Piggies[], RPC2_BoundedBS *VFlagBS, RPC2_CountedBS *PiggyCOP2);
#define ViceValidateAttrsPlusSHA_OP	64
extern ARG ViceValidateAttrsPlusSHA_ARGS[];
#define ViceValidateAttrsPlusSHA_PTR	ViceValidateAttrsPlusSHA_ARGS

#ifdef __cplusplus
}
#endif
#define srvOPARRAYSIZE 65

extern CallCountEntry srv_CallCount[];

extern MultiCallEntry srv_MultiCall[];

extern MultiStubWork srv_MultiStubWork[];

extern long srv_ElapseSwitch;

extern long srv_EnqueueRequest;

#endif /* _VICE_ */
